scr= $0400
col= $d800
vic= $d000; sometimes label also used for CharROM depending on $01
spr= $0c00; area where sprite data are generated

;*= $0801
;!byte $0c,$08,$0a,$00,$9e,$32,$30,$36,$34,$00,$00,$00,$00; SYS2064

*= $0810
; init stuff
	sei
	jsr $10a8; init	music, returns all regs set zero
	stx $d020
	stx $d021	
	stx $286
	dex
	stx vic+21; all sprites on
	stx vic+29; x stretch
	stx vic+23; y stretch
	jsr $e544; KERNAL clearscreen, also fills color RAM with $286 (unless buggy old KERNAL rev which I don't care about)
	ldy #(spr+$200)/64
	ldx #8
	dey
	tya
	sta $7f8-1,x; set sprite pointers
	dex
	bne *-6	
	

start
;direction_y; discarded idea of "flying" (y-pos moving) sprite scroll
;	dec scrollpos_y+1
;	lda scrollpos_y+1
;val_y	
;	cmp #$2e
;	bne +
;	lda direction_y;+1
;	eor #$20
;	sta direction_y;+1
;	lda val_y+1
;	eor #%11000110
;	sta val_y+1

+
	lda scrollbase_x+1	
	sec
	sbc #$08
	sta scrollbase_x+1	

scrollcol
	ldx #$00
	lda flashtab,x
	ldx #8
	sta vic+39-1,x
	dex
	bne *-4

scrollpos_y	
	lda #$dc;e8;80
	sta vic+1
	sta vic+3
	sta vic+5
	sta vic+7
	sta vic+9
	sta vic+11
	sta vic+13
	sta vic+15

	ldy #%11100000
scrollbase_x	
	lda #23;#64+24
	sta vic
	clc
	adc #48
	sta vic+2
	adc #48
	sta vic+4
	adc #48
	sta vic+6
	adc #48
	sta vic+8
	adc #48
	sta vic+10
	bcs +
	ldy #%11000000
+	clc
	adc #48
	sta vic+12
	adc #48
	sta vic+14
	sty $d010

	lda #$ff
	cmp $d012
	bne *-3

screencolor
	lda #$00
	and #%00001111
	tax
	eor #%00001111
	sta scrollcol+1
	lda flashtab,x
	sta $d021
	
	lda scrollval+1
	eor #%00000100
	sta scrollval+1
	
scrollval	
	lda #$c0
	sta $d016
	and #%00000100
	bne repeat

; if no logo hardscroll -> play music and do sprite scroll
	jsr $10c0;3fa0; PLAY ADRESS		

	inc screencolor+1

	lda scrollbase_x+1
	cmp #7
	bne ++; only refresh sprites when x-pos softscroll is done
	
	inc readtext_lo+1
	bne +
	inc readtext_hi+1
+	lda #<spr+6
	sta target+1
	lda #>spr+6
	sta target+2
	jsr writesprites_bottom
	lda #23
	sta scrollbase_x+1	
++	
	jmp start
	
repeat
	ldx #$05
	bne logopointer
	lda #$05
	sta repeat+1
	inc swingpointer+1
	lda swingpointer+1
	cmp #$06
	bne logopointer
	lda #$00
	sta swingpointer+1	
	inc logopointer+1
	lda logopointer+1
	cmp #$09
	bne logopointer
	lda #$02
	sta logopointer+1

logopointer	
	ldx #$00
	lda logo,x
	tax
	beq +
	clc
	lda #$00
-	adc #06
	dex
	bne -
	
+	clc
swingpointer
	adc #$ff
	tax
hardswing; originally thought about changing directions, hence label "swing"
	lda data,x
	ldx #$20
	tay
	and #%00010000; do normal deciphering of the 6x5 px charset characters "MAYD!"
	jsr calculate
	sta scr+39+(0*40)
	sta scr+39+(1*40)
	sta scr+39+(2*40)
	sta scr+39+(3*40)	
	sta scr+39+(4*40)
	tya
	and #%00001000	
	jsr calculate
	sta scr+39+(0*40)+(200*1)
	sta scr+39+(1*40)+(200*1)
	sta scr+39+(2*40)+(200*1)
	sta scr+39+(3*40)+(200*1)	
	sta scr+39+(4*40)+(200*1)	
	tya
	and #%00000100	
	jsr calculate		
	sta scr+39+(0*40)+(200*2)
	sta scr+39+(1*40)+(200*2)
	sta scr+39+(2*40)+(200*2)
	sta scr+39+(3*40)+(200*2)	
	sta scr+39+(4*40)+(200*2)		
	tya
	and #%00000010	
	jsr calculate
	sta scr+39+(0*40)+(200*3)
	sta scr+39+(1*40)+(200*3)
	sta scr+39+(2*40)+(200*3)
	sta scr+39+(3*40)+(200*3)	
	sta scr+39+(4*40)+(200*3)	
	tya
	and #%00000001	
	jsr calculate	
	sta scr+39+(0*40)+(200*4)
	sta scr+39+(1*40)+(200*4)
	sta scr+39+(2*40)+(200*4)
	sta scr+39+(3*40)+(200*4)	
	sta scr+39+(4*40)+(200*4)		
	
	tya
	and #%00100000; check extra bytes 5 and 6 for some extra effects
	beq +
	lda #$a0
	sta scr+39+200
+	tya
	and #%01000000	
	beq +
	lda repeat+1
	cmp #$01
	bne +
	lda #$a0
	sta scr+39+400
	sta scr+39+400+(1*40)
	sta scr+39+400+(2*40)
	sta scr+39+400+(3*40)
	sta scr+39+400+(4*40)	
+	

hardscroll; must be unrolled like this to prevent glitches
	ldx #00
-	lda scr+1,x
	sta scr,x
	lda scr+1+40,x
	sta scr+40,x	
	lda scr+1+80,x
	sta scr+80,x
	lda scr+1+120,x
	sta scr+120,x
	lda scr+1+160,x
	sta scr+160,x	
	inx
	cpx #39
	bne -
	ldx #00
-	lda scr+1+(200*1),x
	sta scr+(200*1),x
	lda scr+1+40+(200*1),x
	sta scr+40+(200*1),x	
	lda scr+1+80+(200*1),x
	sta scr+80+(200*1),x
	lda scr+1+120+(200*1),x
	sta scr+120+(200*1),x
	lda scr+1+160+(200*1),x
	sta scr+160+(200*1),x	
	inx
	cpx #39
	bne -
	ldx #00
-	lda scr+1+(200*2),x
	sta scr+(200*2),x
	lda scr+1+40+(200*2),x
	sta scr+40+(200*2),x	
	lda scr+1+80+(200*2),x
	sta scr+80+(200*2),x
	lda scr+1+120+(200*2),x
	sta scr+120+(200*2),x
	lda scr+1+160+(200*2),x
	sta scr+160+(200*2),x	
	inx
	cpx #39
	bne -
	ldx #00
-	lda scr+1+(200*3),x
	sta scr+(200*3),x
	lda scr+1+40+(200*3),x
	sta scr+40+(200*3),x	
	lda scr+1+80+(200*3),x
	sta scr+80+(200*3),x
	lda scr+1+120+(200*3),x
	sta scr+120+(200*3),x
	lda scr+1+160+(200*3),x
	sta scr+160+(200*3),x	
	inx
	cpx #39
	bne -	
	ldx #00
-	lda scr+1+(200*4),x
	sta scr+(200*4),x
	lda scr+1+40+(200*4),x
	sta scr+40+(200*4),x	
	lda scr+1+80+(200*4),x
	sta scr+80+(200*4),x
	lda scr+1+120+(200*4),x
	sta scr+120+(200*4),x
	lda scr+1+160+(200*4),x
	sta scr+160+(200*4),x	
	inx
	cpx #39
	bne -	
	
	dec repeat+1
checkspace
	lda #$ef; "Space" pressed?
	cmp $dc01
	bne +
	jmp $fce2
+	jmp start

calculate
	bne +
	lda #$a0
	jmp ++
+	txa
++	rts

writesprites_bottom; this CharROM to sprite data plotter eats raster time like hell :D
				   ; but as it's not called in frames with hardscolling, no problem
	lda #$32
	sta $01
readtext_lo
	lda #<text
readtext_hi	
	ldx #>text	
writesprites
	sta source+1
	stx source+2
	lda #8
	sta spritestotal+1
onceagain
writechar
	lda target+1
	sta restorex+1
oneofthree
	lda #3
	sta chrs+1
singlechar 
	ldx #8
	stx times+1
	lda #>vic;fnt
	sta loop+2
source
	lda text;,1
	cmp #$ff
	bne +
	lda #<text
	sta readtext_lo+1
	lda #>text
	sta readtext_hi+1
	lda #32
+	cmp #33
	bmi charvalok
	cmp #65
	bmi +
	and #%00011111
	jmp charvalok
+	inc loop+2
charvalok
	asl
	asl
	asl
	tax
	ldy #21
loop
	lda vic+7,x
target
	sta spr+$200+6,y	
	dey
	dey
	dey
	dex
	dec times+1
times
	lda #00
	cmp #00
	bne loop
	inc target+1
	inc source+1
	bne +
	inc source+2
+	
	dec chrs+1
chrs
	lda #00
	cmp #00
	beq leaveline
	jmp singlechar
leaveline
restorex
	lda #$00
	clc
	adc #24
	sta target+1
leavesprite
	lda restorex+1
	clc
	adc #64
	sta target+1
	bcc +
	inc target+2

+	dec spritestotal+1
spritestotal
	ldx #0
	beq +
	jmp onceagain
+

	lda #$37
	sta $01
	rts

	
logo
	!byte 5,5,0,1,2,3,1,2,4; "  MAYDAY!"

data
	!byte %00111111; M
	!byte %00010000
	!byte %00111100
	!byte %00010000
	!byte %00011111
	!byte 0
	!byte %00111111; A
	!byte %00010100
	!byte %00010100
	!byte %00010100
	!byte %00011111
	!byte 0
	!byte %00011101; Y
	!byte %00000101
	!byte %00000101
	!byte %01000101
	!byte %00011111
	!byte 0
	!byte %00111111; D
	!byte %00010001
	!byte %00010001
	!byte %00010001
	!byte %00011111
	!byte 0
	!byte %00011101; !
	!byte 0
	!byte 0
	!byte 0
	!byte 0
	!byte 0
	!byte 0; empty/space char
	!byte 0
	!byte 0
	!byte 0
	!byte 0
	!byte 0

flashtab
	!byte $00,$00,$06,$06,$04,$04,$0e,$0e,$03,$03,$0e,$0e,$04,$04,$06,$06
	; of course could have lived with 8 but doubling was easiest way to slow down flashing to prevent epilieptic seizures
	; some alternative color patterns following
;	!byte $00,$0b,$0c,$0f,$01,$0f,$0c,$0b
;	!byte $00,$09,$08,$07,$01,$07,$08,$09
;	!byte $00,$06,$04,$0e,$03,$0e,$04,$06
;	!byte $00,$0b,$0c,$05,$0d,$05,$0c,$0b
;	!byte $00,$00,$0b,$0b,$0c,$0c,$05,$05,$0d,$0d,$05,$05,$0c,$0c,$0b,$0b

!ct scr
text; of course really little RAM for text in this version as proof of concept
;     probably I'd use RAM following music normally
	!tx "                        "
	!tx "raw2ktro by theryk 23/12/2017!   "
	!tx "cheers 2 3ad afl atl ex flt fcg g*p hf lxt n0 [o] & u!   merry xmas!"
	!tx "                        "
	!byte $ff

*= $0c00; just a reminder that sprite data are generated here
	
*= $0e00
!bin "C:\C64\Mayday\8KIntroCompo\No_More0e.dat",,2
;slightly hacked music data of No More (C)1987 Future Freak/Space Express
;I killed all CIA timer stuff for easier way of playing at the cost of slightly different pace/pitch
